@echo off

setlocal enableDelayedExpansion

:: Set tools location
SET "pubCmd=C:\PS4-Fake-PKG-Tools-3.87\orbis-pub-cmd.exe"

:: y: To autogenerate DLC unlocker without any prompt (change contentId and title).
:: n: Prompt the user to enter dlc info.
SET "autostart=y"

:: y: remove all autogenerated files.
:: n: don't delete anything.
SET "cleanup=y"

:: y: add dlc icon and wait the user to add the icon file.
:: n: create dlc unlocker without icon.
SET "addIcon=y"

:: When autostart is y, this info will be used in autogenerated dlc unlocker.
SET "contentId=EP0002-CUSA24267_00-CODCWDISCONLY001"
SET "title=Call of Duty®: Black Ops Cold War Content 7 License"

:: Be good and use well known passcode and let others unpack your package.
SET "passcode=00000000000000000000000000000000"

:: Leave everything else as is
if "%autostart%"=="y" goto :start

call :readDlcInfo

:start
call :init
call :createSfx
mkdir %sceSys% 2>NUL
if "%addIcon%"=="y" call :waitForIcon
call :createGp4
call :createDlcPackage
IF %ERRORLEVEL% EQU 0 ( 
    echo you should now have dlc unlocker file as :
    echo %dlcPkg%
)
IF %ERRORLEVEL% NEQ 0 ( 
    echo Something went wrong, check the error message in the log file : %dlclog%
    echo mostly you forget to add icon file.
)
if "%cleanup%"=="y" call :cleanup
goto :eof

::
:: Prepare files path and dlc info.
::
:init
SET titleId=%contentId:~7,9%
SET currentDatetime=2021-12-21 12:21:12
SET scriptPath=%~dp0%
SET sceSys=%scriptPath%sce_sys\
SET paramSfx=%scriptPath%param.sfx
SET paramSfo=%sceSys%param.sfo
SET icon0=%sceSys%icon0.png
SET dlcGp4=%scriptPath%dlc.gp4
SET dlcPkg=%scriptPath%%contentId%-A0000-V0100.pkg
SET dlclog=%scriptPath%%contentId%.log
goto :eof

::
:: Prompt the user for DLC info.
::
:readDlcInfo
echo Enter DLC Content Id, ex. 
echo EU -^> EP0002-CUSA24267_00-CODCWDISCONLY001
echo US -^> UP0002-CUSA15010_00-CODCWDISCONLY001
set /p contentId="-> "
echo Enter DLC Title, ex. 
echo Call of Duty®: Black Ops Cold War Content 7 License
set /p title="-> "
CHOICE /C yn /M "Add dlc ICON"
IF %ERRORLEVEL% EQU 2 SET addIcon=n
IF %ERRORLEVEL% EQU 1 SET addIcon=y
goto :eof

::
:: Create param.sfx file for the dlc
::
:createSfx
echo ^<?xml version="1.0" encoding="utf-8" standalone="yes"?^>> %paramSfx%
echo ^<paramsfo^>>> %paramSfx%
echo  ^<param key="ATTRIBUTE"^>0^</param^>>> %paramSfx%
echo  ^<param key="CATEGORY"^>ac^</param^>>> %paramSfx%
echo  ^<param key="CONTENT_ID"^>%contentId%^</param^>>> %paramSfx%
echo  ^<param key="FORMAT"^>obs^</param^>>> %paramSfx%
echo  ^<param key="TITLE"^>%title%^</param^>>> %paramSfx%
echo  ^<param key="TITLE_ID"^>%titleId%^</param^>>> %paramSfx%
echo  ^<param key="VERSION"^>01.00^</param^>>> %paramSfx%
echo ^</paramsfo^>>> %paramSfx%
goto :eof

::
:: Give the user chance to add icon
::
:waitForIcon
echo.
echo please add the icon as following path : %icon0%
SET /p _=Preess [Enter] to start creating DLC unlocker...
echo.
goto :eof

::
:: Create gp4 file for the dlc
::
:createGp4
echo ^<?xml version="1.0" encoding="utf-8" standalone="yes"?^>>%dlcGp4%
echo ^<psproject fmt="gp4" version="1000"^>>>%dlcGp4%
echo   ^<volume^>>>%dlcGp4%
echo     ^<volume_type^>pkg_ps4_ac_nodata^</volume_type^>>>%dlcGp4%
echo     ^<volume_id^>PS4VOLUME^</volume_id^>>>%dlcGp4%
echo     ^<volume_ts^>%currentDatetime%^</volume_ts^>>>%dlcGp4%
echo     ^<package content_id="%contentId%" passcode="%passcode%"/^>>>%dlcGp4%
echo   ^</volume^>>>%dlcGp4%
echo   ^<files img_no="0"^>>>%dlcGp4%
echo     ^<file targ_path="sce_sys/param.sfo"/^>>>%dlcGp4%
if "%addIcon%"=="n" goto :skipIcon
echo     ^<file targ_path="sce_sys/icon0.png"/^>>>%dlcGp4%
:skipIcon
echo   ^</files^>>>%dlcGp4%
echo   ^<rootdir^>>>%dlcGp4%
echo     ^<dir targ_name="sce_sys"/^>>>%dlcGp4%
echo   ^</rootdir^>>>%dlcGp4%
echo ^</psproject^>>>%dlcGp4%
goto :eof

::
:: Create DLC Package
::
:createDlcPackage
%pubCmd% sfo_create %paramSfx% %paramSfo%
%pubCmd% img_create --no_progress_bar %dlcGp4% %dlcPkg% 1>%dlclog%
goto :eof

::
:: Remove all files used during package creation
::
:cleanup
del /f %dlcGp4%
del /f %paramSfx%
del /f %paramSfo%
del /f %icon0% 2>NUL
rd %sceSys%
goto :eof
